"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JupyterWidget = exports.ErrorBoundary = void 0;
const react_1 = __importDefault(require("react"));
const base = __importStar(require("@jupyter-widgets/base"));
const JupyterPhosphorWidget = base.JupyterPhosphorWidget || base.JupyterLuminoWidget;
class ErrorBoundary extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.state = { hasError: false, error: null };
    }
    static getDerivedStateFromError(error) {
        return { hasError: true, error };
    }
    componentDidCatch(error, errorInfo) { }
    render() {
        // @ts-ignore
        if (this.state.hasError) {
            // @ts-ignore
            const error = this.state.error.message;
            return (react_1.default.createElement("div", null,
                react_1.default.createElement("h1", null, "Error"),
                ";",
                react_1.default.createElement("pre", null, error),
                react_1.default.createElement("button", { onClick: () => this.setState({ hasError: false }) }, "Try again")));
        }
        // @ts-ignore
        return this.props.children;
    }
}
exports.ErrorBoundary = ErrorBoundary;
function JupyterWidget({ widget, view, }) {
    const [element, setElement] = react_1.default.useState(null);
    react_1.default.useLayoutEffect(() => {
        /* Copied from ipyvue:
           https://github.com/widgetti/ipyvue/blob/d307dbdceaa05f01fe22be57d157d02c9ee8fbdf/js/src/VueRenderer.js#L11 */
        let currentView = null;
        let destroyed = false;
        if (element != null) {
            view.create_child_view(widget).then((newView) => {
                currentView = newView;
                // since create view is async, the component instance might be destroyed before the view is created
                if (!destroyed) {
                    element.innerHTML = "";
                    if (JupyterPhosphorWidget &&
                        // @ts-ignore
                        (newView.pWidget || newView.luminoWidget || newView.lmWidget)) {
                        JupyterPhosphorWidget.attach(
                        // @ts-ignore
                        newView.pWidget || newView.luminoWidget || newView.lmWidget, element);
                    }
                    else {
                        // @ts-ignore
                        console.error("Could not attach widget to DOM using Lumino or Phosphor. Fallback to normal DOM attach", JupyterPhosphorWidget, newView);
                        element.appendChild(newView.el);
                    }
                }
                else {
                    currentView.remove();
                }
            });
        }
        return () => {
            if (currentView) {
                // In order to avoid an error in phosphor, we add the node to the body before removing it.
                // (current.remove triggers a phosphor detach)
                // To be sure we do not cause any flickering, we hide the node before moving it.
                const widget = currentView.pWidget ||
                    currentView.luminoWidget ||
                    currentView.lmWidget;
                widget.node.style.display = "none";
                document.body.appendChild(widget.node);
                currentView.remove();
            }
            else {
                destroyed = true;
            }
        };
    }, [element, widget.cid]);
    return react_1.default.createElement("div", { ref: setElement }, "widget placeholder");
}
exports.JupyterWidget = JupyterWidget;
//# sourceMappingURL=components.js.map