"use strict";
// Copyright (c) Maarten A. Breddels
// Distributed under the terms of the Modified BSD License.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactView = exports.ReactModel = exports.ImportMapView = exports.ImportMap = exports.ModuleView = exports.Module = void 0;
const base_1 = require("@jupyter-widgets/base");
const React = __importStar(require("react"));
const react_1 = require("react");
const ReactJsxRuntime = __importStar(require("react/jsx-runtime"));
const ReactReconcilerContants = __importStar(require("react-reconciler/constants"));
const ReactReconciler = __importStar(require("react-reconciler"));
const ReactDOM = __importStar(require("react-dom"));
// @ts-ignore
const ReactDOMClient = __importStar(require("react-dom/client"));
// @ts-ignore
require("../css/widget.css");
const utils_1 = require("./utils");
const version_1 = require("./version");
// import * as Babel from '@babel/standalone';
// TODO: find a way to ship es-module-shims with the widget
// @ts-ignore
// import 'es-module-shims';
const sucrase_1 = require("sucrase");
const components_1 = require("./components");
const moduleResolveFunctions = {};
const modules = {};
function provideModule(moduleName, module) {
    if (moduleResolveFunctions[moduleName]) {
        moduleResolveFunctions[moduleName](module);
    }
    else {
        modules[moduleName] = Promise.resolve(module);
    }
}
function requestModule(moduleName) {
    if (!modules[moduleName]) {
        modules[moduleName] = new Promise((resolve) => (moduleResolveFunctions[moduleName] = resolve));
    }
    return modules[moduleName];
}
let importMapConfigurationResolver = null;
let importMapConfigurationPromise = null;
function provideImportMapConfiguration() {
    if (importMapConfigurationResolver) {
        importMapConfigurationResolver();
    }
    else {
        importMapConfigurationPromise = Promise.resolve();
    }
}
function requestImportMapConfiguration() {
    if (!importMapConfigurationPromise) {
        importMapConfigurationPromise = new Promise((resolve) => {
            importMapConfigurationResolver = resolve;
        });
    }
}
// @ts-ignore
// const react16Code = require('!!raw-loader!./react16.js');
// import react16Code from 'raw-loader!./react16.mjs';
// console.log(react16Code)
// this will do for now
let importShimLoaded = null;
function ensureImportShimLoaded() {
    return __awaiter(this, void 0, void 0, function* () {
        if (importShimLoaded == null) {
            importShimLoaded = utils_1.loadScript("module", "https://ga.jspm.io/npm:es-module-shims@1.7.0/dist/es-module-shims.js");
        }
        return yield importShimLoaded;
    });
}
// function autoExternalReactResolve(
//   id: string,
//   parentUrl: string,
//   resolve: (arg0: any, arg1: any) => any,
// ) {
//   const shipsWith =
//     id == "react" ||
//     id == "react-dom" ||
//     id == "react/jsx-runtime" ||
//     id == "react-dom/client" ||
//     id == "react-reconciler" ||
//     id == "react-reconciler/constants";
//   const alreadyPatched = parentUrl.includes("?external=react,react-dom");
//   const parentIsEsmSh = parentUrl.startsWith("https://esm.sh/");
//   const isBlob = id.startsWith("blob:");
//   if (!shipsWith && !id.includes("://") && !parentIsEsmSh) {
//     id = "https://esm.sh/" + id;
//   }
//   if (!shipsWith && !alreadyPatched && !isBlob) {
//     id = id + "?external=react,react-dom";
//   }
//   return resolve(id, parentUrl);
// }
// @ts-ignore
window.esmsInitOptions = {
    shimMode: true,
    mapOverrides: true,
};
let react18ESMUrls = null;
let react16ESMUrls = null;
function ensureReactSetup(version) {
    if (version == 18) {
        if (react18ESMUrls == null) {
            react18ESMUrls = {
                react: utils_1.expose(React),
                "react-dom": utils_1.expose(ReactDOM),
                "react/jsx-runtime": utils_1.expose(ReactJsxRuntime),
                "react-dom/client": utils_1.expose(ReactDOMClient),
                "react-reconciler": utils_1.expose(ReactReconciler),
                "react-reconciler/constants": utils_1.expose(ReactReconcilerContants),
            };
        }
        return react18ESMUrls;
    }
    else if (version == 16) {
        if (react16ESMUrls == null) {
            // react16ESMUrls = {urlReact: expose(React16), urlReactDom: expose(ReactDOM16)};
        }
        return react16ESMUrls;
    }
}
class ComponentData {
    constructor(component, key) {
        this.component = component;
        this.key = key;
    }
    asElement(view) {
        return React.createElement(this.component, { view, key: this.key });
    }
}
const widgetToReactComponent = (widget) => __awaiter(void 0, void 0, void 0, function* () {
    if (widget instanceof ReactModel) {
        return new ComponentData(yield widget.component, widget.model_id);
    }
    else {
        return new ComponentData(({ view }) => components_1.JupyterWidget({ widget, view }), widget.model_id);
    }
});
const entriesToObj = (acc, [key, value]) => {
    acc[key] = value;
    return acc;
};
function replaceWidgetWithComponent(data, get_model) {
    return __awaiter(this, void 0, void 0, function* () {
        const type = typeof data;
        if (type === "string" && data.startsWith("IPY_MODEL_")) {
            const modelId = data.substring("IPY_MODEL_".length);
            const model = yield get_model(modelId);
            return widgetToReactComponent(model);
        }
        if (["string", "number", "boolean", "bigint"].includes(type) ||
            data == null) {
            return data;
        }
        if (data instanceof base_1.WidgetModel) {
            return widgetToReactComponent(data);
        }
        if (Array.isArray(data)) {
            return Promise.all(data.map((d) => __awaiter(this, void 0, void 0, function* () { return replaceWidgetWithComponent(d, get_model); })));
        }
        return (yield Promise.all(Object.entries(data).map(([key, value]) => __awaiter(this, void 0, void 0, function* () {
            return [
                key,
                yield replaceWidgetWithComponent(value, get_model),
            ];
        })))).reduce(entriesToObj, {});
    });
}
function replaceComponentWithElement(data, view) {
    const type = typeof data;
    if (["string", "number", "boolean", "bigint"].includes(type) ||
        data == null) {
        return data;
    }
    if (data instanceof ComponentData) {
        return data.asElement(view);
    }
    if (Array.isArray(data)) {
        return data.map((d) => replaceComponentWithElement(d, view));
    }
    const entriesToObj = (acc, [key, value]) => {
        acc[key] = value;
        return acc;
    };
    return Object.entries(data)
        .map(([key, value]) => [key, replaceComponentWithElement(value, view)])
        .reduce(entriesToObj, {});
}
class Module extends base_1.WidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: Module.model_name, _model_module: Module.model_module, _model_module_version: Module.model_module_version, _view_name: Module.view_name, _view_module: Module.view_module, _view_module_version: Module.view_module_version });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        this.addModule();
    }
    destroy(options) {
        if (this.codeUrl) {
            URL.revokeObjectURL(this.codeUrl);
        }
        return super.destroy(options);
    }
    updateImportMap() {
        return __awaiter(this, void 0, void 0, function* () {
            yield ensureImportShimLoaded();
            yield requestImportMapConfiguration();
            const reactImportMap = ensureReactSetup(this.get("react_version"));
            const importMap = {
                imports: Object.assign({}, reactImportMap),
            };
            importShim.addImportMap(importMap);
        });
    }
    addModule() {
        return __awaiter(this, void 0, void 0, function* () {
            const code = this.get("code");
            try {
                let name = this.get("name");
                if (this.codeUrl) {
                    URL.revokeObjectURL(this.codeUrl);
                }
                this.codeUrl = URL.createObjectURL(new Blob([code], { type: "text/javascript" }));
                let dependencies = this.get("dependencies") || [];
                this.set("status", "Waiting for dependencies: " + dependencies.join(", "));
                yield Promise.all(dependencies.map((x) => requestModule(x)));
                yield ensureImportShimLoaded();
                yield this.updateImportMap();
                this.set("status", "Loading module...");
                let module = yield importShim(this.codeUrl);
                importShim.addImportMap({ imports: { [name]: this.codeUrl } });
                this.set("status", "Loaded module!");
                provideModule(name, module);
            }
            catch (e) {
                console.error(e);
                this.set("status", "Error loading module: " + e);
            }
        });
    }
}
exports.Module = Module;
Module.model_name = "Module";
Module.model_module = version_1.MODULE_NAME;
Module.model_module_version = version_1.MODULE_VERSION;
Module.view_name = "ModuleView"; // Set to null if no view
Module.view_module = version_1.MODULE_NAME; // Set to null if no view
Module.view_module_version = version_1.MODULE_VERSION;
class ModuleView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.root = null;
    }
    render() {
        return __awaiter(this, void 0, void 0, function* () {
            this.el.classList.add("jupyter-react-widget");
            this.root = ReactDOMClient.createRoot(this.el);
            const Component = () => {
                const [status, setStatus] = react_1.useState(this.model.get("status"));
                react_1.useEffect(() => {
                    this.listenTo(this.model, "change:status", () => {
                        setStatus(this.model.get("status"));
                    });
                    return () => {
                        this.stopListening(this.model, "change:status");
                    };
                }, []);
                const name = this.model.get("name");
                return (React.createElement("div", null,
                    name,
                    " status: ",
                    status));
            };
            this.root.render(React.createElement(Component, null));
        });
    }
    remove() {
        var _a;
        (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
    }
}
exports.ModuleView = ModuleView;
class ImportMap extends base_1.WidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ImportMap.model_name, _model_module: ImportMap.model_module, _model_module_version: ImportMap.model_module_version, _view_name: ImportMap.view_name, _view_module: ImportMap.view_module, _view_module_version: ImportMap.view_module_version, import_map: {
                imports: {},
                scopes: {},
            } });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        this.updateImportMap();
        this.on("change:import_map", () => {
            this.updateImportMap();
        });
    }
    destroy(options) {
        this.off("change:import_map");
        return super.destroy(options);
    }
    updateImportMap() {
        return __awaiter(this, void 0, void 0, function* () {
            yield ensureImportShimLoaded();
            const importMapWidget = this.get("import_map");
            const importMap = {
                imports: Object.assign({}, importMapWidget.imports),
                scopes: Object.assign({}, importMapWidget.scopes),
            };
            importShim.addImportMap(importMap);
            provideImportMapConfiguration();
        });
    }
}
exports.ImportMap = ImportMap;
ImportMap.model_name = "ImportMap";
ImportMap.model_module = version_1.MODULE_NAME;
ImportMap.model_module_version = version_1.MODULE_VERSION;
ImportMap.view_name = "ImportMap"; // Set to null if no view
ImportMap.view_module = version_1.MODULE_NAME; // Set to null if no view
ImportMap.view_module_version = version_1.MODULE_VERSION;
class ImportMapView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.root = null;
    }
    render() {
        return __awaiter(this, void 0, void 0, function* () {
            this.el.classList.add("jupyter-react-widget");
            this.root = ReactDOMClient.createRoot(this.el);
            const Component = () => {
                const [importMap, setImportMap] = react_1.useState(this.model.get("import_map"));
                react_1.useEffect(() => {
                    this.listenTo(this.model, "change:import_map", () => {
                        setImportMap(this.model.get("import_map"));
                    });
                    return () => {
                        this.stopListening(this.model, "change:import_map");
                    };
                }, []);
                const importMapJson = JSON.stringify(importMap, null, 2);
                return (React.createElement("pre", null,
                    "importmap:",
                    importMapJson));
            };
            this.root.render(React.createElement(Component, null));
        });
    }
    remove() {
        var _a;
        (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
    }
}
exports.ImportMapView = ImportMapView;
class ReactModel extends base_1.DOMWidgetModel {
    constructor() {
        super(...arguments);
        this.compiledCode = null;
        this.compileError = null;
        this.codeUrl = null;
        // this used so that the WrapperComponent can be rendered synchronously,
        this.currentComponentToWrapOrError = null;
    }
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ReactModel.model_name, _model_module: ReactModel.model_module, _model_module_version: ReactModel.model_module_version, _view_name: ReactModel.view_name, _view_module: ReactModel.view_module, _view_module_version: ReactModel.view_module_version });
        // TODO: ideally, we only compile code in the widget model, but the react hooks are
        // super convenient.
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        this.component = new Promise((resolve, reject) => {
            this.resolveComponent = resolve;
            this.rejectComponent = reject;
        });
        this.queue = Promise.resolve();
        this.on("change:_esm", () => __awaiter(this, void 0, void 0, function* () {
            this.enqueue(() => __awaiter(this, void 0, void 0, function* () {
                this.compileCode();
                yield this.updateComponentToWrap();
            }));
        }));
        this.on("change:_module change:_type", () => __awaiter(this, void 0, void 0, function* () {
            this.enqueue(() => __awaiter(this, void 0, void 0, function* () {
                yield this.updateImportMap();
                yield this.updateComponentToWrap();
            }));
        }));
        this._initialSetup();
    }
    enqueue(fn) {
        // this makes sure that callbacks and _initialSetup are executed in order
        // and not in parallel, which can lead to race conditions
        this.queue = this.queue.then(() => __awaiter(this, void 0, void 0, function* () {
            yield fn();
        }));
        return this.queue;
    }
    _initialSetup() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.enqueue(() => __awaiter(this, void 0, void 0, function* () {
                yield this.updateImportMap();
                this.compileCode();
                try {
                    let component = yield this.createWrapperComponent();
                    this.resolveComponent(component);
                }
                catch (e) {
                    console.error(e);
                    this.rejectComponent(e);
                }
            }));
            // await this.createComponen();
        });
    }
    updateImportMap() {
        return __awaiter(this, void 0, void 0, function* () {
            yield ensureImportShimLoaded();
            yield requestImportMapConfiguration();
            const reactImportMap = ensureReactSetup(this.get("_react_version"));
            const importMap = {
                imports: Object.assign({}, reactImportMap),
            };
            importShim.addImportMap(importMap);
        });
    }
    compileCode() {
        // using babel is a bit of an art, so leaving this code for if we
        // want to switch back to babel. However, babel is very large compared
        // to sucrase
        // Babel.registerPreset("my-preset", {
        //   presets: [
        //     [Babel.availablePresets["react"]],
        //     // [Babel.availablePresets["typescript"], { allExtensions: true }],
        //   ]
        // });
        // Babel.registerPlugin("importmap", pluginImport());
        const code = this.get("_esm");
        this.compileError = null;
        if (!code) {
            this.compiledCode = null;
            return;
        }
        if (this.get("_debug")) {
            console.log("original code:\n", code);
        }
        try {
            // using babel:
            // return Babel.transform(code,  { presets: ["react", "es2017"], plugins: ["importmap"] }).code;
            // using sucrase:
            this.compiledCode = sucrase_1.transform(code, {
                transforms: ["jsx", "typescript"],
                filePath: "test.tsx",
            }).code;
            if (this.get("_debug")) {
                console.log("compiledCode:\n", this.compiledCode);
            }
        }
        catch (e) {
            console.error(e);
            this.compileError = e;
        }
    }
    updateComponentToWrap() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let component = yield this.createComponentToWrap();
                this.currentComponentToWrapOrError = component;
                this.trigger("component", component);
            }
            catch (e) {
                console.error(e);
                this.trigger("component", e);
            }
        });
    }
    createComponentToWrap() {
        return __awaiter(this, void 0, void 0, function* () {
            let moduleName = this.get("_module");
            let type = this.get("_type");
            let _dependencies = this.get("_dependencies") || [];
            yield Promise.all(_dependencies.map((x) => requestModule(x)));
            if (this.compileError) {
                return () => React.createElement("pre", null, this.compileError.message);
            }
            else {
                let module = null;
                // html element like div or button
                if (!moduleName && !this.compiledCode && type) {
                    return type;
                }
                if (!this.compiledCode && !moduleName && !type) {
                    return () => (React.createElement("div", null, "no component provided, pass _esm, or _module and _type"));
                }
                else if (this.compiledCode) {
                    if (this.codeUrl) {
                        URL.revokeObjectURL(this.codeUrl);
                    }
                    this.codeUrl = URL.createObjectURL(new Blob([this.compiledCode], { type: "text/javascript" }));
                    module = yield importShim(this.codeUrl);
                    if (!module) {
                        return () => React.createElement("div", null, "error loading module");
                    }
                }
                else {
                    module = yield importShim(moduleName);
                    if (!module) {
                        return () => React.createElement("div", null,
                            "no module found with name ",
                            moduleName);
                    }
                }
                let component = module[type || "default"];
                if (!component) {
                    if (type) {
                        return () => (React.createElement("div", null,
                            "no component found in module ",
                            moduleName,
                            " (with name ",
                            type,
                            ")"));
                    }
                    else {
                        return () => (React.createElement("div", null,
                            "no component found in module ",
                            moduleName,
                            " (it should be exported as default)"));
                    }
                }
                else {
                    if (this.compiledCode) {
                        const needsMuiFix = this.compiledCode.indexOf("@mui") !== -1;
                        if (needsMuiFix) {
                            let muiFix = yield utils_1.setUpMuiFixModule();
                            const componentToWrap = component;
                            // console.log("muiFix", muiFix);
                            // @ts-ignore
                            component = (props) => {
                                // console.log("component wrapper fix", props)
                                // return componentToWrap(props);
                                return muiFix.styleWrapper(componentToWrap(props));
                            };
                        }
                    }
                    return component;
                }
            }
        });
    }
    createWrapperComponent() {
        return __awaiter(this, void 0, void 0, function* () {
            // we wrap the component in a wrapper that puts in all the props from the
            // widget model, and handles events, etc
            const get_model = this.widget_manager.get_model.bind(this.widget_manager);
            let initialChildrenComponents = yield replaceWidgetWithComponent({ children: this.get("children") }, get_model);
            // const resolveFormatters = async () => {
            //   let formatterDict = this.get("formatters") || {};
            //   let formatterModules : any = {};
            //   for (const key of Object.keys(formatterDict)) {
            //       // @ts-ignore
            //       let module = await importShim(formatterDict[key]);
            //       formatterModules[key] = module;
            //   }
            //   return formatterModules;
            // }
            // let formatterModules = await resolveFormatters();
            // console.log("formatterModules", formatterModules);
            const initialModelProps = yield replaceWidgetWithComponent(this.get("props"), get_model);
            try {
                this.currentComponentToWrapOrError = yield this.createComponentToWrap();
            }
            catch (e) {
                this.currentComponentToWrapOrError = e;
            }
            const isSpecialProp = (key) => {
                const specialProps = [
                    "children",
                    "props",
                    "tabbable",
                    "layout",
                    "tooltip",
                ];
                if (specialProps.find((x) => x === key)) {
                    return true;
                }
                if (key.startsWith("_")) {
                    return true;
                }
                return false;
            };
            const WrapperComponent = (_a) => {
                var { view } = _a, parentProps = __rest(_a, ["view"]);
                const [component, setComponent] = react_1.useState(() => this.currentComponentToWrapOrError);
                React.useEffect(() => {
                    this.listenTo(this, "component", (component) => {
                        console.log("set component", component);
                        setComponent(() => component);
                    });
                    return () => {
                        this.stopListening(this, "component");
                    };
                }, []);
                const [childrenComponents, setChildrenComponents] = react_1.useState(initialChildrenComponents);
                const updateChildren = () => {
                    console.log("update children");
                    this.enqueue(() => __awaiter(this, void 0, void 0, function* () {
                        setChildrenComponents(yield replaceWidgetWithComponent({ children: this.get("children") }, get_model));
                    }));
                };
                const [modelProps, setModelProps] = react_1.useState(initialModelProps);
                const updateModelProps = () => {
                    this.enqueue(() => __awaiter(this, void 0, void 0, function* () {
                        setModelProps(yield replaceWidgetWithComponent(this.get("props"), get_model));
                    }));
                };
                react_1.useEffect(() => {
                    this.listenTo(this, "change:props", updateModelProps);
                    this.listenTo(this, "change:children", updateChildren);
                    for (const key of Object.keys(this.attributes)) {
                        if (isSpecialProp(key)) {
                            continue;
                        }
                        this.listenTo(this, `change:${key}`, updateChildren);
                    }
                    return () => {
                        this.stopListening(this, "change:props", updateModelProps);
                        this.stopListening(this, "change:children", updateChildren);
                        for (const key of Object.keys(this.attributes)) {
                            if (isSpecialProp(key)) {
                                continue;
                            }
                            this.stopListening(this, `change:${key}`, updateChildren);
                        }
                    };
                }, []);
                const events = {};
                for (const event_name of this.attributes["_event_names"]) {
                    const handler = (value, buffers) => {
                        if (buffers) {
                            const validBuffers = buffers instanceof Array && buffers[0] instanceof ArrayBuffer;
                            if (!validBuffers) {
                                console.warn("second argument is not an BufferArray[View] array");
                                buffers = undefined;
                            }
                        }
                        const saveValue = utils_1.eventToObject(value);
                        console.log("sending", event_name, saveValue, view);
                        this.send({ event_name, data: saveValue }, this.callbacks(view), buffers);
                    };
                    events[event_name] = handler;
                }
                // React.createElement('div', {"aria-activedescendant": "foo"}})
                // <div aria-activedescendant="foo"></div>
                // for (const key of Object.keys(modelProps)) {
                //   if(formatterModules[key]) {
                //     modelProps[key] = formatterModules[key].py2js(modelProps[key]);
                //   }
                // }
                // console.log("children", children);
                const childrenProps = replaceComponentWithElement(childrenComponents, view);
                if (childrenProps.children && childrenProps.children.length === 1) {
                    childrenProps.children = childrenProps.children[0];
                }
                // useEffect(() => {
                //   // force render every 2 seconds
                //   const interval = setInterval(() => {
                //     forceRerender();
                //   }, 2000);
                //   return () => {
                //     clearInterval(interval);
                //   }
                // }, []);
                //const [r//]
                const backboneProps = {};
                for (const key of Object.keys(this.attributes)) {
                    if (isSpecialProp(key)) {
                        continue;
                    }
                    backboneProps[key] = this.get(key);
                    backboneProps["set" + key.charAt(0).toUpperCase() + key.slice(1)] = (value) => {
                        this.set(key, value);
                        // this.touch();
                        this.save_changes(this.callbacks(view));
                    };
                }
                const props = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, replaceComponentWithElement(modelProps, view)), backboneProps), parentProps), events), childrenProps);
                if (component instanceof Error) {
                    throw component;
                }
                return React.createElement(component, props);
            };
            return WrapperComponent;
        });
    }
    destroy(options) {
        if (this.codeUrl) {
            URL.revokeObjectURL(this.codeUrl);
        }
        return super.destroy(options);
    }
}
exports.ReactModel = ReactModel;
ReactModel.serializers = Object.assign(Object.assign({}, base_1.DOMWidgetModel.serializers), { children: { deserialize: base_1.unpack_models } });
ReactModel.model_name = "ReactModel";
ReactModel.model_module = version_1.MODULE_NAME;
ReactModel.model_module_version = version_1.MODULE_VERSION;
ReactModel.view_name = "ReactView"; // Set to null if no view
ReactModel.view_module = version_1.MODULE_NAME; // Set to null if no view
ReactModel.view_module_version = version_1.MODULE_VERSION;
class ReactView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.root = null;
    }
    render() {
        return __awaiter(this, void 0, void 0, function* () {
            this.el.classList.add("jupyter-react-widget");
            // using babel is a bit of an art, so leaving this code for if we
            this.root = ReactDOMClient.createRoot(this.el);
            const Component = yield this.model.component;
            this.root.render(React.createElement(components_1.ErrorBoundary, null,
                React.createElement(Component, { view: this })));
        });
    }
    remove() {
        var _a;
        (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
    }
}
exports.ReactView = ReactView;
//# sourceMappingURL=widget.js.map